;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sumo brother disassembly
; By nekoh
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                           dcb "INIT"
                           JSL $01ACF9             
                           AND #$1F                
                           STA $1540,X             
                           LDY #$00                
                           LDA $D1                   
                           SEC                       
                           SBC $E4,X       
                           STA $0F                   
                           LDA $D2                   
                           SBC $14E0,X     
                           BPL RETURNER          
                           INY                               
                           TYA                       
                           STA $157C,X                           
RETURNER:                  RTL        


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                           
                           dcb "MAIN"
Bnk3CallSprMain:           PHB                       
                           PHK                       
                           PLB                             
                           JSR Fishbone         
                           PLB                       
                           RTL                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

FishboneMaxSpeed:          db $10,$F0
FishboneAcceler:           db $01,$FF


FISHBONE:                  JSR FishboneGfx         
                           LDA $9D     
                           BNE Return          
                           JSR SubOffscreen0Bnk3   
                           JSL $01A7DC    
                           JSL $018022   
                           TXA                       
                           ASL                       
                           ASL                       
                           ASL                       
                           ASL                       
                           ADC $13      
                           AND #$7F                
                           BNE LABEL1          
                           JSL $01ACF9           
                           AND #$01         
                           BNE LABEL1           
                           LDA #$0C                
                           STA $1558,X
             
LABEL1:                    LDA $C2,X     
                           JSL $0086DF          

FishbonePtrs:              dw GO_HERE_ONE&$FFFF          
                           dw GO_HERE_TWO&$FFFF           

RETURN:                    RTS                       ; Return 

GO_HERE_ONE:               INC $1570,X             
                           LDA $1570,X                                
                           LSR                       
                           AND #$01                
                           STA $1602,X             
                           LDA $1540,X             
                           BEQ LABEL2           
                           AND #$01                
                           BNE RETURN1          
                           LDY $157C,X     
                           LDA $B6,X    
                           CMP FishboneMaxSpeed,Y  
                           BEQ RETURN1          
                           CLC                       
                           ADC FishboneAcceler,Y   
                           STA $B6,X    

RETURN1:                   RTS                       ; Return 
  
LABEL2:                    INC $C2,X     
                           LDA #$30                
                           STA $1540,X             
                           RTS                       ; Return 

GO_HERE_TWO:               STZ $1602,X             
                           LDA $1540,X             
                           BEQ LABEL4           
                           AND #$03                
                           BNE RETURN2          
                           LDA $B6,X    
                           BEQ RETURN3          
                           BPL LABEL3           
                           INC $B6,X    
RETURN2:                   RTS                       ; Return 
  
LABEL3:                    DEC $B6,X    
RETURN3:                   RTS                       ; Return 

LABEL4:                    STZ $C2,X     
                           LDA #$30                
                           STA $1540,X             
                           RTS                       ; Return 


FishboneDispX:             db $F8,$F8,$10,$10
FishboneDispY:             db $00,$08
FishboneGfxProp:           db $4D,$CD,$0D,$8D
FishboneTailTiles:         db $A3,$A3,$B3,$B3

FishboneGfx:               JSL $0190B2    
                           LDY $15EA,X   ; Y = Index into sprite OAM 
                           LDA $1558,X             
                           CMP #$01                
                           LDA #$A6                
                           BCC CODE_03979E           
                           LDA #$A8                
CODE_03979E:               STA $0302,Y          
                           JSR GET_DRAW_INFO     
                           LDA $157C,X     
                           ASL                       
                           STA $02                   
                           LDA $1602,X             
                           ASL                       
                           STA $03                   
                           LDA $15EA,X   
                           CLC                       
                           ADC.B #$04                
                           STA $15EA,X   
                           TAY                       
                           PHX                       
                           LDX.B #$01                
CODE_0397BD:               LDA $01                   
                           CLC                       
                           ADC FishboneDispY,X     
                           STA $0301,Y         
                           PHX                       
                           TXA                       
                           ORA $02                   
                           TAX                       
                           LDA $00                   
                           CLC                       
                           ADC FishboneDispX,X     
                           STA $0300,Y         
                           LDA FishboneGfxProp,X   
                           ORA $64                   
                           STA $0303,Y          
                           PLA                       
                           PHA                       
                           ORA $03                   
                           TAX                       
                           LDA FishboneTailTiles,X 
                           STA $0302,Y          
                           PLX                       
                           INY                       
                           INY                       
                           INY                       
                           INY                       
                           DEX                       
                           BPL CODE_0397BD           
                           PLX                       
                           LDY #$00                
                           LDA #$02                
                           JSL $01B7B3      
Return0397F8:              RTS                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sub Horizontal Position Bank 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubHorzPosBnk3:     LDY #$00                
                    LDA $94         
                    SEC                       
                    SBC $E4,X       
                    STA $0F                   
                    LDA $95       
                    SBC $14E0,X     
                    BPL Return03B828          
                    INY                       
Return03B828:       RTS                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sub Vertical Position Bank 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubVertPosBnk3:     LDY #$00                
                    LDA $96         
                    SEC                       
                    SBC $D8,X       
                    STA $0F                   
                    LDA $97       
                    SBC $14D4,X     
                    BPL Return03B83A          
                    INY                       
Return03B83A:       RTS                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Get Draw Info Bank 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sprite Graphics Routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_03B83B:                      db $40,$B0
DATA_03B83D:                      db $01,$FF
DATA_03B83F:                      db $30,$C0,$A0,$80,$A0,$40,$60,$B0
DATA_03B847:                      db $01,$FF,$01,$FF,$01,$00,$01,$FF

SubOffscreen0Bnk3:  STZ $03                     ; / 
                    JSR IsSprOffScreenBnk3      ; \ if sprite is not off screen, return 
                    BEQ RETURNONE               ; / 
                    LDA $5B                     ; \  vertical level 
                    AND #$01                    ;  | 
                    BNE VerticalLevelBnk3       ; / 
                    LDA $D8,X                   ; \ 
                    CLC                         ;  | 
                    ADC #$50                    ;  | if the sprite has gone off the bottom of the level... 
                    LDA $14D4,X                 ;  | 
                    ADC #$00                    ;  | 
                    CMP #$02                    ;  | 
                    BPL OffScrEraseSprBnk3      ; /    ...erase the sprite 
                    LDA $167A,X                 ; \ if "process offscreen" flag is set, return 
                    AND #$04                    ;  | 
                    BNE RETURNONE               ; / 
                    LDA $13      
                    AND #$01                
                    ORA $03                   
                    STA $01                   
                    TAY                       
                    LDA $1A    
                    CLC                       
                    ADC DATA_03B83F,Y       
                    ROL $00                   
                    CMP $E4,X       
                    PHP                       
                    LDA $1B    
                    LSR $00                   
                    ADC DATA_03B847,Y       
                    PLP                       
                    SBC $14E0,X     
                    STA $00                   
                    LSR $01                   
                    BCC CODE_03B8A8           
                    EOR #$80                
                    STA $00        
           
CODE_03B8A8:        LDA $00                   
                    BPL RETURNONE   
       
OffScrEraseSprBnk3: LDA $14C8,X                 ; \ If sprite status < 8, permanently erase sprite 
                    CMP #$08                    ;  | 
                    BCC OffScrKillSprBnk3       ; / 
                    LDY $161A,X                 ; \ Branch if should permanently erase sprite 
                    CPY #$FF                    ;  | 
                    BEQ OffScrKillSprBnk3       ; / 
                    LDA #$00                    ; \ Allow sprite to be reloaded by level loading routine 
                    STA $1938,Y                 ; / 
OffScrKillSprBnk3:  STZ $14C8,X 
            
RETURNONE:          RTS                         ; Return 

VerticalLevelBnk3:  LDA $167A,X                 ; \ If "process offscreen" flag is set, return 
                    AND #$04                    ;  | 
                    BNE RETURNONE               ; / 
                    LDA $13                     ; \ Return every other frame 
                    LSR                         ;  | 
                    BCS RETURNONE               ; / 
                    AND #$01                
                    STA $01                   
                    TAY                       
                    LDA $1C    
                    CLC                       
                    ADC DATA_03B83B,Y       
                    ROL $00                   
                    CMP $D8,X       
                    PHP                       
                    LDA $1D  
                    LSR $00                   
                    ADC DATA_03B83D,Y       
                    PLP                       
                    SBC $14D4,X     
                    STA $00                   
                    LDY $01                   
                    BEQ CODE_03B8F5           
                    EOR #$80                
                    STA $00  
                 
CODE_03B8F5:        LDA $00                   
                    BPL RETURNONE          
                    BMI OffScrEraseSprBnk3 
   
IsSprOffScreenBnk3: LDA $15A0,X                 ; \ If sprite is on screen, A = 0  
                    ORA $186C,X                 ;  | 
                    RTS                         ; / Return 

